"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var makePop = function (array, setValues) {
    return function () {
        return setValues(array.slice(0, -1));
    };
};
var makePush = function (array, setValues) {
    return function (value) {
        return setValues(__spreadArray(__spreadArray([], array, true), [value], false));
    };
};
var makeShift = function (array, setValues) {
    return function () {
        return setValues(array.slice(1));
    };
};
var makeUnshift = function (array, setValues) {
    return function (value) {
        return setValues(__spreadArray([value], array, true));
    };
};
var makeReverse = function (array, setValues) {
    return function () {
        return setValues(__spreadArray([], array, true).reverse());
    };
};
var makeRemoveByIndex = function (array, setValues) {
    return function (index) {
        return setValues(__spreadArray(__spreadArray([], array.slice(0, index), true), array.slice(index + 1), true));
    };
};
var makeRemoveByValue = function (array, setValues) {
    return function (value) {
        return setValues(array.filter(function (item) { return item !== value; }));
    };
};
var makeFilter = function (array, setValues) {
    return function (predicate, thisArg) {
        return setValues(array.filter(predicate, thisArg));
    };
};
var makeInsertItem = function (array, setValues) {
    return function (index, value) {
        return setValues(__spreadArray(__spreadArray(__spreadArray([], array.slice(0, index), true), [value], false), array.slice(index), true));
    };
};
var makeMoveItem = function (array, setValues) {
    return function (fromIndex, toIndex) {
        if (fromIndex > toIndex) {
            setValues(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], array.slice(0, toIndex), true), [
                array[fromIndex]
            ], false), array.slice(toIndex + 1, fromIndex), true), [
                array[toIndex]
            ], false), array.slice(fromIndex + 1), true));
        }
        else
            makeMoveItem(array, setValues)(toIndex, fromIndex);
    };
};
var useImmutableArray = function (array) {
    var _a = React.useState(array), values = _a[0], setValues = _a[1];
    return React.useMemo(function () { return ({
        pop: makePop(values, setValues),
        push: makePush(values, setValues),
        shift: makeShift(values, setValues),
        unshift: makeUnshift(values, setValues),
        reverse: makeReverse(values, setValues),
        removeByIndex: makeRemoveByIndex(values, setValues),
        removeByValue: makeRemoveByValue(values, setValues),
        filter: makeFilter(values, setValues),
        insertItem: makeInsertItem(values, setValues),
        moveItem: makeMoveItem(values, setValues),
        values: values,
        setValues: setValues
    }); }, [values]);
};
exports.default = useImmutableArray;
